
//
// ==================================
	String version="36.4";
// ==================================

#include <stdint.h>

#include <TFT_eSPI.h> // Hardware-specific library
#include "Free_Fonts.h"
#include "SPI.h"

#include "MCDU.h"
#include "FG_data.h"
#include "Fonctions1.h"

#include <WiFi.h>
#include <HTTPClient.h> // Remarque: les fonctions WiFi consomment 50% de la mémoire flash (de programme)

const char* ssid = "PFD_srv"; // nous nous connectons en tant que client au même serveur (le PFD) que le ND.
const char* password = "72r4TsJ28"; // doit être identique à celui du serveur du PFD

const char* srvName_flags = "http://192.168.4.1/flags";
const char* srvName_num_bali = "http://192.168.4.1/num_bali";
//const char* srvName_msg = "http://192.168.4.1/msg";

String recp_flags;  // qui sont émis par le serveur (PFD) en réponse à la requette

String recp_msg;
String memo_msg;

String recp_num_bali;
String memo_num_bali;


Etiquette Etiq_1;
Etiquette Etiq_2;
Etiquette Etiq_3;
Etiquette Etiq_4;
Etiquette Etiq_5;
Etiquette Etiq_6;
Etiquette Etiq_7;
Etiquette Etiq_7b;
Etiquette Etiq_8;
Etiquette Etiq_9;
Etiquette Etiq_10;
Etiquette Etiq_10b;
Etiquette Etiq_10c;
Etiquette Etiq_11;
Etiquette Etiq_12;
Etiquette Etiq_13;
Etiquette Etiq_14;
Etiquette Etiq_15;
Etiquette Etiq_16;

Led Led1;
Led Led2;
Led Led3;
Led Led4;
Led Led5;



//-------------------------------------------------------------------------------------------
// pour la 'carte universelle'
// voir schéma de la platine ESP32
// numérotation dans l'ordre de la disposition des pins du connecteur des boutons, en partant de GND


uint16_t bouton1=1; // (2^0) -> positionnera 1 bit dans le mot
const int GPIO_bouton1 = 33;
bool bouton1_etat;
bool memo_bouton1_etat;

uint16_t bouton2=2; // (2^1)
const int GPIO_bouton2 = 32;
bool bouton2_etat;
bool memo_bouton2_etat;

uint16_t bouton3=4; // (2^2)
const int GPIO_bouton3 = 34;
bool bouton3_etat;
bool memo_bouton3_etat;

uint16_t bouton4=8; // (2^3)
const int GPIO_bouton4 = 36;
bool bouton4_etat;
bool memo_bouton4_etat;

uint16_t bouton5=16; // 16 (2^4)
const int GPIO_bouton5 = 39;
bool bouton5_etat;
bool memo_bouton5_etat;

uint16_t bouton6=32; // 32 (2^5)
const int GPIO_bouton6 = 35;
bool bouton6_etat;
bool memo_bouton6_etat;
//-------------------------------------------------------------------------------------------

uint16_t boutons =0; // mot dont chaque bit correspond à un bouton connecté à ce module MCDU

uint8_t  SDcardOk=0;

int16_t num_bali=0;
uint16_t flags_i;
uint16_t memo_flags_i;


uint32_t memo_micros=0;
uint32_t temps_ecoule;
uint8_t num_ligne_msg=0;

uint16_t couleur_ligne;

uint32_t bmp_offset=0;

uint16_t data_rect1[300*50]; // pixels d'un rectangle


void init_afficheur()
{
	TFT480.init();
	TFT480.setRotation(1); // 0..3 à voir, suivant disposition de l'afficheur
	
	TFT480.fillScreen(NOIR);
	TFT480.setTextColor(NOIR, BLANC);
}


void init_WiFi()
{
	WiFi.persistent(false);
	WiFi.begin(ssid, password);
	delay(2000);
}


void httpGetParams() // paramètres divers depuis le PFD & envoi état des états des boutons en argument de la requette
{
	String s1;
	String s2;

	HTTPClient http;

	s1= "?btMCDU=";  // sw1 (nom arbitraire..) pour désigner l'argument n°1 envoyé dans l'URL de la requête
	s2= String(boutons);
	s1+= s2;

	http.begin(srvName_flags+s1);
	int httpResponseCode = http.GET();
	if (httpResponseCode>0)	{ recp_flags = http.getString();}
	http.end();
}


/*
void httpGet_msg()
{
// envoie requete au serveur

	HTTPClient http;
	
	http.begin(srvName_msg);
	int httpResponseCode = http.GET();
	if (httpResponseCode>0)	{ recp_msg = http.getString();}
	http.end();
}
*/


void httpGet_num_bali()
{
// envoie requete au serveur

	HTTPClient http;
	
	http.begin(srvName_num_bali);
	int httpResponseCode = http.GET();
	if (httpResponseCode>0)	{ recp_num_bali = http.getString();}
	http.end();
}



void interroge_WiFi()
{
// voir les "server.on()" dans la fonction "setup()" du code du PFD pour la source des données

	if(WiFi.status()== WL_CONNECTED )
	{
		httpGetParams();
		flags_i = recp_flags.toInt();
	}

}

/*
void requete_WiFi_2()
{
// voir les "server.on()" dans la fonction "setup()" du code du PFD pour la source des données
// plus précisément la ligne ->  server.on("/msg", ....
	recp_msg = "";
	if(WiFi.status()== WL_CONNECTED )
	{
		httpGet_msg(); // envoie requete au serveur, avec position des switch en argument.
	}
}
*/

void requete_WiFi_3()
{
// voir les "server.on()" dans la fonction "setup()" du code du PFD pour la source des données
	recp_num_bali= "";
	if(WiFi.status()== WL_CONNECTED )
	{
		httpGet_num_bali(); // envoie requete au serveur, avec position des switch en argument.
	}
}



void affi_flags() // nombre jaune en haut à droite
{
	TFT480.setTextFont(1);
	TFT480.setTextColor(JAUNE);

	affi_int_en_binaire(flags_i, 400, 2);
}


void affi_etat_boutons() // nombre vert en haut à gauche
{
	uint16_t x0=10;
	uint16_t y0=23;
	
	interroge_WiFi(); // et envoie les arguments le cas échéant
	
	TFT480.fillRect(x0, y0, 30, 12, GRIS_TRES_FONCE); // efface le nombre précédemment affiché
	//TFT480.setTextFont(1);
	TFT480.setFreeFont(FF1);
	TFT480.setTextColor(VERT);
	String s1 = String(boutons);
	TFT480.drawString(s1, x0, y0);
}




void init_etiquettes() // pour l'affichage des données, voir la fonction "affi_data_piste()"
{
	uint16_t x0 = 120;
	uint16_t y0 = 5;
	uint16_t xi;
	uint16_t yi;

	xi=x0;
	yi=y0;

	
	TFT480.drawRoundRect(xi-10, yi+10, 300, 65, 3, GRIS); // panel décollage

	TFT480.setFreeFont(FF5);
	
	Etiq_1.init(xi,yi,110,24);
	Etiq_1.st="DECOLLAGE";
	Etiq_1.set_couleurs(GRIS, GRIS_TRES_FONCE);

	yi+=30;


	TFT480.setFreeFont(FF1);
	
	TFT480.setTextColor(BLANC, NOIR);
	TFT480.drawString("Rudder:", xi+5, yi+5);

	TFT480.setFreeFont(FF5);
	
	Etiq_2.init(xi+100,yi,80,24);
	Etiq_2.st="Manuel";
	Etiq_2.set_couleurs(GRIS, GRIS_TRES_FONCE);

	Etiq_3.init(xi+200,yi,80,24);
	Etiq_3.st="Auto";
	Etiq_3.set_couleurs(GRIS, GRIS_TRES_FONCE);

	yi+=50;
	
	////Etiq_4.init(xi,yi,180,24);
	////Etiq_4.st="EN VOL";
	////Etiq_4.set_couleurs(GRIS, GRIS_TRES_FONCE);
	//yi+=30;

	Etiq_4.init(xi+110,yi,180,24);
	Etiq_4.st="AutoPilot de FG";
	Etiq_4.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	yi+=40;

	TFT480.setFreeFont(FF1);

	TFT480.setTextColor(BLANC, NOIR);
	TFT480.drawString("AutoPilot ESP:", xi, yi+5);

	TFT480.setFreeFont(FF5);

	Etiq_5.init(xi+160,yi,55,24);
	Etiq_5.st="Manu";
	Etiq_5.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	Etiq_6.init(xi+225,yi,65,24);
	Etiq_6.st="Route";
	Etiq_6.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);
	

	yi+=30;

	TFT480.drawRoundRect(xi-10, yi+10, 305, 55, 3, GRIS);

	Etiq_7.init(xi,yi,75,24);
	Etiq_7.st="ROUTE";
	Etiq_7.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	TFT480.drawRoundRect(xi-10, yi+10, 305, 55, 3, GRIS);

	TFT480.setFreeFont(FF1);

	Etiq_7b.init(xi+ 90,yi,200,24); 
	Etiq_7b.st="----"; // OACI + Nom
	Etiq_7b.set_couleurs(BLEU_CLAIR, NOIR);
	

	yi+=30;

	TFT480.setFreeFont(FF1);
	TFT480.setTextColor(BLANC, NOIR);
	TFT480.drawString("to", xi, yi+5);

	TFT480.setFreeFont(FF5);

	TFT480.setFreeFont(FF5);

	Etiq_8.init(xi+28,yi,46,24);
	Etiq_8.st="RWY";
	Etiq_8.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	Etiq_9.init(xi+81,yi,46,24);
	Etiq_9.st="ptA";
	Etiq_9.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	Etiq_10.init(xi+133,yi,46,24);
	Etiq_10.st="ptB";
	Etiq_10.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	Etiq_10b.init(xi+184,yi,50,24);
	Etiq_10b.st="crc1"; // Tours de piste (circling) dans un sens
	Etiq_10b.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	Etiq_10c.init(xi+240,yi,50,24);
	Etiq_10c.st="crc2"; // // Tours de piste dans l'autre sens
	Etiq_10c.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);
	

	yi+=55;

	//TFT480.drawRoundRect(xi-10, yi+10, 300, 55, 3, GRIS);
	
	Etiq_11.init(xi,yi,100,24);
	Etiq_11.st=" FINALE";
	Etiq_11.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	

	Etiq_12.init(xi+105,yi,100,24);
	Etiq_12.st=" LANDING";
	Etiq_12.set_couleurs(GRIS, GRIS_TRES_FONCE);

	Etiq_14.init(xi+210,yi-13,80,24);
	Etiq_14.st=" LONG";
	Etiq_14.set_couleurs(GRIS, GRIS_TRES_FONCE);
	
	Etiq_15.init(xi+210,yi+13,80,24);
	Etiq_15.st=" SHORT";
	Etiq_15.set_couleurs(GRIS, GRIS_TRES_FONCE);


	yi+=50;

	Etiq_16.init(xi+60,yi,100,24);
	Etiq_16.st=" AU SOL";
	Etiq_16.set_couleurs(GRIS, GRIS_TRES_FONCE);	

	Etiq_13.init(xi+190,yi,100,24);
	Etiq_13.st=" ROULAGE";
	Etiq_13.set_couleurs(GRIS, GRIS_TRES_FONCE);
	
}



void init_SDcard()
{
	String s1;

	uint16_t y=0;
	TFT480.setTextColor(VERT, NOIR);
	TFT480.drawString("Init SDcard", 0, y);
	y+=20;
	
 	if(!SD.begin())
	{
		TFT480.drawString("Card Mount Failed", 0, y);
		delay (2000);
		TFT480.fillRect(0, 0, 480, 320, NOIR); // efface
		return;
	}
  

    uint8_t cardType = SD.cardType();

    if(cardType == CARD_NONE)
    {
        TFT480.drawString("No SDcard", 0, y);
        delay (2000);
		TFT480.fillRect(0, 0, 480, 320, NOIR); // efface
        return;
    }

    SDcardOk=1;

    TFT480.drawString("SDcard Type: ", 0, y);
	if(cardType == CARD_SD)    {TFT480.drawString("SDSC", 150, y);}
    else if(cardType == CARD_SDHC) {TFT480.drawString("SDHC", 150, y);}

	y+=20;
	
	uint32_t cardSize = SD.cardSize() / (1024 * 1024);
	s1=(String)cardSize + " GB";
	TFT480.drawString("SDcard size: ", 0, y);
	TFT480.drawString(s1, 150, y);

  
//Serial.printf("Total space: %lluMB\n", SD.totalBytes() / (1024 * 1024));
//Serial.printf("Used space: %lluMB\n", SD.usedBytes() / (1024 * 1024));
}


/** ***********************************************************************************
		IMAGE.bmp					
***************************************************************************************/


/**
Rappel et décryptage de la fonction Color_To_565 : (elle se trouve dans le fichier LCDWIKI_KBV.cpp)

//Pass 8-bit (each) R,G,B, get back 16-bit packed color

uint16_t Color_To_565(uint8_t r, uint8_t g, uint8_t b)
{
	return ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | ((b & 0xF8) >> 3);
}

0xF8 = 11111000
0xFC = 11111100

(r & 0xF8) -> 5 bit de gauche de r (on ignore donc les 3 bits de poids faible)
(g & 0xFC) -> 6 bit de gauche de g (on ignore donc les 2 bits de poids faible)
(b & 0xF8) -> 5 bit de gauche de b (on ignore donc les 3 bits de poids faible)

rrrrr---
gggggg--
bbbbb---

après les décalages on obtient les 16 bits suivants:

rrrrr---========
     gggggg--===
        ===bbbbb

soit après le ou :

rrrrrggggggbbbbb

calcul de la Fonction inverse : 
RGB565_to_888
**/

uint16_t Color_To_565(uint8_t r, uint8_t g, uint8_t b)
{
	return ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | ((b & 0xF8) >> 3);
}


void RGB565_to_888(uint16_t color565, uint8_t *R, uint8_t *G, uint8_t *B)
{
	*R=(color565 & 0xFFFFF800) >> 8;
	*G=(color565 & 0x7E0) >> 3;
	*B=(color565 & 0x1F) << 3 ;
}




uint16_t bmp_width;
uint16_t bmp_heigh;


uint16_t read_16(File fp)
{
    uint8_t low;
    uint16_t high;
    low = fp.read();
    high = fp.read();
    return (high<<8)|low;
}



uint32_t read_32(File fp)
{
    uint16_t low;
    uint32_t high;
    low = read_16(fp);
    high = read_16(fp);
    return (high<<8)|low;   
}



void write_16(uint16_t v16, File fp)
{
    uint8_t low, high;
	
	low = v16 & 0xFF;
	high= v16 >>8;
    
    fp.write(low);
    fp.write(high);
}


void write_32(uint32_t v32, File fp)
{
    uint16_t low, high;
	
	low = v32 & 0xFFFF;
	high= v32 >>16;
    
    write_16(low, fp);
    write_16(high, fp);
}



bool teste_bmp_header(File fp)
{
    if(read_16(fp) != 0x4D42)  { return false;  } // (2 bytes) The header field used to identify the BMP
    read_32(fp); // (4 bytes) get bmp size (nombre total d'octets)
    read_32(fp); // (4 bytes) get creator information
    bmp_offset = read_32(fp); // (4 bytes) get offset information
    read_32(fp);//get DIB information

// ici on a lu 16 octets  
	bmp_width = read_32(fp); //(4 bytes) get width and heigh information
	bmp_heigh = read_32(fp); //(4 bytes)
	
// ici on a lu 24 octets 	
    //if(read_16(fp)!= 1) {return false;}
    read_16(fp);
    //if(read_32(fp)!= 0) {return false;}
    return true;
}



uint8_t LumCtr(uint8_t vi, float lum, float ctr)
{
	float v2;
	uint8_t result;
	v2 = ((float)vi - lum) * ctr;
	if (v2<0) {v2=0;}
	if (v2>255) {v2=255;}
	result = (uint8_t) v2;
	return result;
}



void draw_bmp(uint16_t x0, uint16_t y0, uint8_t rot, float lum, float contraste, File* fp)
{

	//sram = freeRam(); Serial.print("03-freeRam="); Serial.println(sram);
		uint16_t i,j,k,p,m=0;
		uint16_t y1;
		uint8_t bmp_data[2*3]={0};
		uint16_t bmp_color[2];
		
		fp->seek(bmp_offset);
		for(i=0; i<bmp_heigh; i++)
		{
			for(j=0; j<(bmp_width/2); j++)
			{
				m=0;
				fp->read(bmp_data,2*3);
				for(k=0; k<2; k++)
				{
bmp_color[k]= Color_To_565(LumCtr(bmp_data[m+2],lum, contraste), LumCtr(bmp_data[m+1],lum, contraste), LumCtr(bmp_data[m+0],lum, contraste));
					m+=3;
				}
				for(p=0; p<2; p++)
				{
					if (rot==0)
					{
						y1=y0;
						TFT480.drawPixel(x0+i, y0+j*2+p, bmp_color[p]);
					}
					if (rot==1)
					{
						y1=160-y0;
						TFT480.drawPixel(x0+j*2+p,320-(y1+i), bmp_color[p]);
					}
				}   
			}
		}
}




void affi_img(uint16_t x0, uint16_t y0, float lum, float contraste, const char* filename1)
{

	File bmp_file;
	TFT480.setFreeFont(FF1);
	TFT480.setTextColor(ORANGE, NOIR);
	bmp_file = SD.open(filename1);
	if(!bmp_file)
	{

		bmp_file.close(); 
		return;
	}
	if(!teste_bmp_header(bmp_file))
	{
		bmp_file.close(); 
		return;
	}
	
	draw_bmp(x0, y0, 1, lum, contraste, &bmp_file);

	bmp_file.close(); 
//	delay(1000);

}





/** -----------------------------------------------------------------------------------
		CAPTURE D'ECRAN vers SDcard				
/** ----------------------------------------------------------------------------------- */

void write_TFT480_on_SDcard() // enregistre le fichier .bmp
{
	if (SDcardOk==1)
	{
		////TFT480.drawString("capture bmp !", 100, 100);
		////delay(1000);
		
		String s1;
		uint16_t ys=200;
		TFT480.setFreeFont(FF1);
		TFT480.setTextColor(JAUNE, NOIR);
		
		uint16_t x, y;
		uint16_t color565;
		uint16_t bmp_color;
		uint8_t R, G, B;
		
		if( ! SD.exists("/bmp/capture2.bmp"))
		{
			TFT480.fillRect(0, 0, 480, 320, NOIR); // efface
			TFT480.setTextColor(ROUGE, NOIR);
			TFT480.drawString("NO /bmp/capture2.bmp !", 100, ys);
			delay(300);
			TFT480.fillRect(100, ys, 220, 20, NOIR); // efface
			return;
		}


		File File1 = SD.open("/bmp/capture2.bmp", FILE_WRITE); // ouverture du fichier binaire (vierge) en écriture
		if (File1)
		{
	/*
	Les images en couleurs réelles BMP888 utilisent 24 bits par pixel: 
	Il faut 3 octets pour coder chaque pixel, en respectant l'ordre de l'alternance bleu, vert et rouge.
	*/
			uint16_t bmp_offset = 138;
			File1.seek(bmp_offset);

			
			TFT480.setTextColor(VERT, NOIR);
			
			for (y=320; y>0; y--)
			{
				for (x=0; x<480; x++)
				{
					color565=TFT480.readPixel(x, y);

					RGB565_to_888(color565, &R, &G, &B);
					
					File1.write(B); //G
					File1.write(G); //R
					File1.write(R); //B
				}

				s1=(String) (y/10);
				TFT480.fillRect(2, 300, 20, 20, NOIR);
				TFT480.drawString(s1, 2, 300);// affi compte à rebour
			} 

			File1.close();  // referme le fichier
			
			TFT480.fillRect(2, 300, 20, 20, NOIR); // efface le compte à rebour
		}
	}
}

/** ----------------------------------------------------------------------------------- */


void affiche_traits_violets(uint16_t x0, uint16_t yi)
{
	TFT480.fillRect(410, 230, 40, 80, GRIS_TRES_FONCE); // efface
	
	if (read_bit(flags_i, bit_au_sol) == 0)
	{
		// pour la partie haute
		TFT480.drawLine(x0-50, yi-25, x0-20, yi-25,  VIOLET1); affi_indexH(x0-45, yi-25, -1, VIOLET1);
		TFT480.drawLine(x0-20, yi-25, x0-20, yi+10,  VIOLET1);
		TFT480.drawLine(x0-20, yi+10, x0+10, yi+10,  VIOLET1);
	}
	else
	{
		// pour la partie basse (vers étiquette [ROULAGE])
		TFT480.drawLine(x0-50, yi+25, x0-20, yi+25,  VIOLET1); affi_indexH(x0-45, yi+25, -1, VIOLET1);
		TFT480.drawLine(x0-20, yi+10, x0-20, yi+25,  VIOLET1);
		TFT480.drawLine(x0-20, yi+10, x0+10, yi+10,  VIOLET1);
	}
}



void init_Leds() // pour l'affichage des données, voir la fonction "affi_data_piste()"
{
	uint16_t x0 = 460;
	uint16_t y0 = 5;
	uint16_t xi;
	uint16_t yi;

	TFT480.setFreeFont(FF1);
	TFT480.setTextColor(BLANC, NOIR);	

	TFT480.drawRoundRect(x0, y0, 160, 305, 3, GRIS);

	xi=x0+10;
	yi=y0+16;

	TFT480.drawLine(x0-50, yi+25, x0-20, yi+25,  ROUGE); affi_indexH(x0-45, yi+25, -1, ROUGE);
	TFT480.drawLine(x0-20, yi+25, x0-20, yi+10,  ROUGE);
	TFT480.drawLine(x0-20, yi+10, x0+10, yi+10,  ROUGE);

	
	
	Led1.init(xi,yi, 20, 20);
	Led1.set_couleur(ROUGE);
	Led1.eteint();

	yi+=64;

	TFT480.drawLine(x0-50, yi+10, x0+10, yi+10,  JAUNE); affi_indexH(x0-45, yi+10, -1, JAUNE);

	TFT480.setFreeFont(FF1);

	Led2.init(xi,yi, 20, 20);
	Led2.set_couleur(JAUNE);
	Led2.eteint();

	yi+=64;

	TFT480.drawLine(x0-50, yi-10, x0-20, yi-10,  VERT); affi_indexH(x0-45, yi-10, -1, VERT);
	TFT480.drawLine(x0-20, yi-10, x0-20, yi+10,  VERT);
	TFT480.drawLine(x0-20, yi+10, x0+10, yi+10,  VERT);

	
	Led3.init(xi,yi, 20, 20);
	Led3.set_couleur(VERT);
	Led3.eteint();

	yi+=64;
	
	TFT480.drawLine(x0-50, yi-20, x0-20, yi-20,  BLEU); affi_indexH(x0-45, yi-20, -1, BLEU);
	TFT480.drawLine(x0-20, yi-20, x0-20, yi+10,  BLEU);
	TFT480.drawLine(x0-20, yi+10, x0+10, yi+10,  BLEU);	

	Led4.init(xi,yi, 20, 20);
	Led4.set_couleur(BLEU);
	Led4.eteint();

	yi+=64;
	
	affiche_traits_violets(x0, yi);

	Led5.init(xi,yi, 20, 20);
	Led5.set_couleur(VIOLET1);
	Led5.eteint();
}





void setup()
{
    Serial.begin(19200);

    pinMode(GPIO_bouton1, INPUT_PULLUP);
	pinMode(GPIO_bouton1, INPUT_PULLUP);
	pinMode(GPIO_bouton2, INPUT_PULLUP);
	pinMode(GPIO_bouton3, INPUT_PULLUP);
	pinMode(GPIO_bouton4, INPUT_PULLUP);
	pinMode(GPIO_bouton5, INPUT_PULLUP);

	init_afficheur();
	init_WiFi();
	

	TFT480.fillRect(0, 0, 480, 320, NOIR); // efface
	TFT480.setTextColor(BLANC, NOIR);
	TFT480.setFreeFont(FF1);

	uint16_t y=0;
	TFT480.drawString("MCDU", 0, y);
	y+=20;
	String s1="version " + version;
	TFT480.drawString(s1, 0, y);


	init_SDcard();
	
	delay (2000);
	TFT480.fillRect(0, 0, 480, 320, GRIS_TRES_FONCE); // efface

	TFT480.fillRect(5, 2, 100, 310, NOIR);
	TFT480.drawRoundRect(5, 2, 100, 310, 3, BLANC);

	init_FG_bali();
	init_etiquettes();
	init_Leds();

}



void eteint_toutes_etiquettes()
{
	Etiq_1.set_couleurs(GRIS, GRIS_TRES_FONCE); // DECOLLAGE
	Etiq_2.set_couleurs(GRIS, GRIS_TRES_FONCE);
	Etiq_3.set_couleurs(GRIS, GRIS_TRES_FONCE); // [Auto]
	Etiq_4.set_couleurs(GRIS, GRIS_TRES_FONCE); // [Autopilot de FG]
	Etiq_5.set_couleurs(GRIS, GRIS_TRES_FONCE); // [Manu]
	Etiq_6.set_couleurs(GRIS, GRIS_TRES_FONCE); // [Route]
	Etiq_7.set_couleurs(GRIS, GRIS_TRES_FONCE); // [ROUTE]
	Etiq_7b.set_couleurs(BLEU_CLAIR, NOIR);
	Etiq_8.set_couleurs(GRIS, GRIS_TRES_FONCE); // [RWY]
	Etiq_9.set_couleurs(GRIS, GRIS_TRES_FONCE); // [ptA]
	Etiq_10.set_couleurs(GRIS, GRIS_TRES_FONCE);// [ptB]
	Etiq_10b.set_couleurs(GRIS, GRIS_TRES_FONCE); // [crc1]
	Etiq_10c.set_couleurs(GRIS, GRIS_TRES_FONCE); // [crc2]
	Etiq_11.set_couleurs(GRIS, GRIS_TRES_FONCE); // [FINALE]
	Etiq_12.set_couleurs(GRIS, GRIS_TRES_FONCE); // [LANDING]
	Etiq_13.set_couleurs(GRIS, GRIS_TRES_FONCE); // [ROULAGE]
	Etiq_14.set_couleurs(GRIS, GRIS_TRES_FONCE); // [LANDING LONG]
	Etiq_15.set_couleurs(GRIS, GRIS_TRES_FONCE); // [LANDING SHORT]
	Etiq_16.set_couleurs(GRIS, GRIS_TRES_FONCE); // AU SOL
}




void teste_flags_i()  // reçus du PFD ; -> éteint & allume les étiquettes; fonction appelée uniquement si un flag a changé
{

	TFT480.setFreeFont(FF5);
	
	eteint_toutes_etiquettes();
	
	TFT480.setFreeFont(FF5);
	
	if (read_bit(flags_i, bit_decollage) ==1) { Etiq_1.set_couleurs(VERT, GRIS_TRES_FONCE); } // [DECOLLAGE]
	if( read_bit(flags_i, bit_rudder_decol) ==1) { Etiq_3.set_couleurs(NOIR, VERT); }// [Auto]
	
	if (read_bit(flags_i, bit_FG_AP) ==1) { Etiq_4.set_couleurs(VERT, GRIS_TRES_FONCE); }// [Autopilot de FG]
	else {Etiq_4.set_couleurs(GRIS, GRIS_TRES_FONCE);}

	if (read_bit(flags_i, bit_route) ==1)
	{
		Etiq_6.set_couleurs(NOIR, VERT); // [Route]
		Etiq_7.set_couleurs(VERT, GRIS_TRES_FONCE); // [ROUTE]
	}
	else { Etiq_5.set_couleurs(NOIR, VERT); } // [Manu]

	if (read_bit(flags_i, bit_nav_to_piste) ==1) { Etiq_8.set_couleurs(NOIR, VERT); } // [RWY]
	if (read_bit(flags_i, bit_nav_to_ptAA)==1) { Etiq_9.set_couleurs(NOIR, VERT); }// [ptA]
	if (read_bit(flags_i, bit_nav_to_ptBB)==1) { Etiq_10.set_couleurs(NOIR, VERT); } // [ptB]
	if (read_bit(flags_i, bit_nav_to_pti)==1)
	{
		if (read_bit(flags_i, bit_circling)==1)
		{
			if (read_bit(flags_i, bit_sens_circling)==0) { Etiq_10b.set_couleurs(NOIR, VERT);} // [crc1] tour de piste sens 0
			else { Etiq_10c.set_couleurs(NOIR, VERT);}	 // [crc2] tour de piste sens 1		
 		}
	}

	if (read_bit(flags_i, bit_autoland) ==1) { Etiq_11.set_couleurs(NOIR, VERT);} // allume [FINALE]	
	if (read_bit(flags_i, bit_atterrissage) ==1)	{ Etiq_12.set_couleurs(NOIR, VERT); }// [LANDING]
	if (read_bit(flags_i, bit_roulage) ==1)	{ Etiq_13.set_couleurs(NOIR, VERT); }// [ROULAGE]

	if (read_bit(flags_i, bit_au_sol) ==0)
	{
		if (read_bit(flags_i, bit_att_short) ==1)	{ Etiq_15.set_couleurs(NOIR, VERT); } // [LANDING SHORT]
		if (read_bit(flags_i, bit_att_short) ==0)	{ Etiq_14.set_couleurs(NOIR, VERT); } // [LANDING LONG]
	}
	if (read_bit(flags_i, bit_au_sol) ==1)	{ Etiq_16.set_couleurs(NOIR, VERT); } // [AU SOL]
}


/*
void efface_listing()
{
	TFT480.fillRect(8, 40, 95, 265, NOIR);// efface la liste
	num_ligne_msg=0;


	TFT480.setFreeFont(FM12);
	TFT480.setTextColor(ROUGE);

	TFT480.drawString("RAZ", 30, 10);
	delay(1000);
	TFT480.fillRect(8, 5, 95, 265, NOIR);// efface

}
*/


void affi_alerte2(String str1)
{
	uint16_t x0=90;
	uint16_t y0=100;

	for (uint8_t n=0; n<5; n++)
	{
		TFT480.readRect(x0, y0, 300, 50, data_rect1); // memorisation
		
		TFT480.fillRect(x0, y0, 300, 50, BLANC); // efface
		TFT480.drawRoundRect(x0, y0, 300, 50, 3, VERT);

		TFT480.setFreeFont(FMB12);
		TFT480.setTextColor(ROUGE);
		TFT480.drawString(str1, x0+20, y0+10);
		
		delay(500);
		TFT480.fillRect(x0, y0, 300, 50, GRIS_TRES_FONCE); // efface
		
		TFT480.pushRect(x0, y0, 300, 50, data_rect1);
	
		delay(1000);
	}

	TFT480.setFreeFont(FF5);
	
}



void teste_boutons() // boutons locaux
{
// l'int16_t "boutons" sera envoyé au PFD en argument de la requette "httpGetParams()"
// son traitement sera fait par le module PFD,  pas ici.
// voir la partie "BOUTONS du module MCDU" dans la fonction "void traitement_boutons()" dans le code du PFD

	bouton1_etat = digitalRead(GPIO_bouton1); // ROUGE
	if (bouton1_etat != memo_bouton1_etat)
	{
		//efface_listing();
		memo_bouton1_etat = bouton1_etat;
		if (bouton1_etat==1)
		{
			Led1.eteint();
			raz_bit(&boutons, bit_bt1);
		} 
		else
		{
			Led1.allume();

			TFT480.setFreeFont(FF1);
			TFT480.setTextColor(JAUNE);
			
			TFT480.drawString("Desserez frein de park (maj+B)", 120, 60);
			delay(1000);
			TFT480.fillRect(120, 60, 330, 16, GRIS_TRES_FONCE); // efface
			
			set_bit(&boutons, bit_bt1);
		}
		affi_etat_boutons();
	}

	bouton2_etat = digitalRead(GPIO_bouton2); // JAUNE
	if (bouton2_etat != memo_bouton2_etat)
	{
		memo_bouton2_etat = bouton2_etat;
		if (bouton2_etat==1) {Led2.eteint(); raz_bit(&boutons, bit_bt2);}
		else {Led2.allume(); set_bit(&boutons, bit_bt2);}
		affi_etat_boutons();
	}

	bouton3_etat = digitalRead(GPIO_bouton3); // VERT
	if (bouton3_etat != memo_bouton3_etat)
	{
		memo_bouton3_etat = bouton3_etat;
		if (bouton3_etat==1) {Led3.eteint(); raz_bit(&boutons, bit_bt3);}
		else {Led3.allume(); set_bit(&boutons, bit_bt3);}
		affi_etat_boutons();
	}

	bouton4_etat = digitalRead(GPIO_bouton4); // BLEU
	if (bouton4_etat != memo_bouton4_etat)
	{
		memo_bouton4_etat = bouton4_etat;
		if (bouton4_etat==1) {Led4.eteint(); raz_bit(&boutons, bit_bt4);}
		else {Led4.allume(); set_bit(&boutons, bit_bt4);}
		affi_etat_boutons();
	}

	bouton5_etat = digitalRead(GPIO_bouton5); // VIOLET
	if (bouton5_etat != memo_bouton5_etat)
	{
		
		memo_bouton5_etat = bouton5_etat;
		if (bouton5_etat==1)
		{
			Led5.eteint();
			raz_bit(&boutons, bit_bt5);
		}
		else
		{
			Led5.allume();
			set_bit(&boutons, bit_bt5);
			//write_TFT480_on_SDcard();
		}
		affi_etat_boutons();


		
	}
}

/*
void affi_ligne_listing()
{
	if ((recp_msg !="") && (recp_msg !="null") && (recp_msg !="RAZ") ) 
	{
		TFT480.setTextFont(1);
		if(num_ligne_msg==0)
		{
			efface_listing();
		}
		String s1 = String(num_ligne_msg);
		affi_message(s1, 10, 40+9*num_ligne_msg, 97, 0, JAUNE, NOIR, 0);
		
		s1= recp_msg;
		if ((num_ligne_msg %2) == 0) {couleur_ligne = BLEU_FONCE;} else{couleur_ligne = GRIS_FONCE;}
		
		TFT480.fillRect(25, 40+9*num_ligne_msg, 75, 9, couleur_ligne); // fond de la ligne
		TFT480.setTextFont(1);
		//affi_message(s1, 25, 40+9*num_ligne_msg, 87, 0, BLANC, couleur_ligne, 0);

		num_ligne_msg ++;
		if(num_ligne_msg>27){num_ligne_msg=0;}
	}


	if(recp_msg == "alert1")
	{
		affi_alerte2("EMERGENCY landing");
	}

	
	if(recp_msg == "RAZ")
	{
		//delay(500);
		efface_listing();
	}
	
}
*/



void toutes_les_1s() // pour ne pas trop solliciter le serveur
{
	interroge_WiFi(); // et envoie les arguments le cas échéant
	affi_flags();
	affi_etat_boutons();

	if ((liste_bali[num_bali].sens_app_interdit) == 'A')
	{
		Etiq_9.set_couleurs(BLANC, ROUGE);// sens interdit
		//Etiq_10.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);

	} 

	if ((liste_bali[num_bali].sens_app_interdit) == 'B')
	{
		Etiq_10.set_couleurs(BLANC, ROUGE);// sens interdit
		//Etiq_9.set_couleurs(GRIS_CLAIR, GRIS_TRES_FONCE);
	} 
/*
	requete_WiFi_2();
	if(recp_msg != memo_msg)
	{
		memo_msg = recp_msg;
		affi_ligne_listing();
	}
*/

	String s1;
	
	requete_WiFi_3();
	if(recp_num_bali != memo_num_bali)
	{
		memo_num_bali = recp_num_bali;
		
		num_bali = recp_num_bali.toInt();

		s1= (String)liste_bali[num_bali].ID_OACI;
		s1 += " ";
		s1 += (String)liste_bali[num_bali].nom;

		s1 = s1.substring(0,17);

		TFT480.setTextFont(2);
		Etiq_7b.st=s1;
		Etiq_7b.set_couleurs(BLEU_CLAIR, NOIR); // et affiche le texte

		//Etiq_8.set_couleurs(GRIS, GRIS_TRES_FONCE);
		//Etiq_9.set_couleurs(GRIS, GRIS_TRES_FONCE);
		//Etiq_10.set_couleurs(GRIS, GRIS_TRES_FONCE);
		
	}

	//inv_bit(&flags_i, bit_au_sol);
	//init_Leds();
	//affiche_traits_violets(460, 276);

}




void loop()
{

	temps_ecoule = micros() - memo_micros;
	if (temps_ecoule  >= 1E6)  // (>=) et pas strictement égal (==) parce qu'alors on rate l'instant en question
	{
		memo_micros = micros();
		toutes_les_1s();
	}

	teste_boutons(); // local
	
	if(flags_i != memo_flags_i)
	{
		memo_flags_i = flags_i;
		teste_flags_i(); // reçus du PFD
		affiche_traits_violets(460, 276);
	} 

	delay(30);
}




/** ***************************************************************************************
	CLASS Etiquette  // affiche sous forme d'une étiquette colorée
********************************************************************************************/

// Constructeur
Etiquette::Etiquette()
{

}


void Etiquette::init(uint16_t xi, uint16_t yi, uint16_t dxi, uint16_t dyi)
{
	x0 = xi;
	y0 = yi;
	dx = dxi;
	dy = dyi;

	//TFT480.setTextColor(BLANC, NOIR);
	couleur_contour = BLANC; // par défaut
}



void Etiquette::traceContour()
{
	TFT480.drawRoundRect(x0, y0, dx, dy, 3, couleur_contour);
}


void Etiquette::efface()
{
	TFT480.fillRoundRect(x0, y0, dx, dy, 3, couleur_fond);
	traceContour();
	
}



void Etiquette::set_couleurs(uint16_t c_txt, uint16_t c_fond)  // et affiche le texte
{
	couleur_texte = c_txt;
	couleur_fond = c_fond;
	affi_string(); 
}




void Etiquette::affi_string() 
{
// Pour cette méthode, la police de caract doit être choisie au préalable, extérieurement
	efface();
	// TFT480.setFreeFont(FF5); // à parametrer expérieurement avant l'appel
	TFT480.setTextColor(couleur_texte, couleur_fond);
	TFT480.drawString(st, x0+5, y0+5);
}


/** ***************************************************************************************
	CLASS Led  // affiche un petit rectangle coloré
********************************************************************************************/


// Constructeur
Led::Led()
{

}


void Led::init(uint16_t xi, uint16_t yi, uint16_t dxi, uint16_t dyi)
{
	x0 = xi;
	y0 = yi;
	dx = dxi;
	dy = dyi;
}



void Led::allume()
{
	TFT480.fillRect(x0, y0, dx, dy, couleur);
}


void Led::eteint()
{
	TFT480.fillRect(x0, y0, dx, dy, GRIS_TRES_FONCE);
	TFT480.drawRect(x0, y0, dx, dy, couleur); // bordure
}


void Led::set_couleur(uint16_t coul_i)
{
	couleur = coul_i;
}





